// yo sls, credits to him!! //

local ptafterimages = {SKINCOLOR_RED,SKINCOLOR_CRIMSON,SKINCOLOR_EMERALD,SKINCOLOR_FOREST}

freeslot("sfx_djump") 
sfxinfo[sfx_djump].caption = "Double Jump (Sonic R)"



addHook("PlayerThink", function(player)
	if player.mo.afterimages_refresh == nil then
		player.mo.afterimages_refresh = 1
	else
		if player.mo.afterimages_refresh == #ptafterimages then
			player.mo.afterimages_refresh = 1
		else
			player.mo.afterimages_refresh = $ + 1
		end
	end
end)

----------------------------------


addHook("PlayerThink", function(player)
	if player.mo.charging == nil
		player.mo.charging = false
	end
end)


addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "table")
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and not (player.powers[pw_super])
		   player.mo.state = S_PLAY_ROLL
		   S_StartSound(player.mo, sfx_djump)
	       P_SetObjectMomZ(player.mo, 14*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and (player.powers[pw_super])
		   player.mo.state = S_PLAY_ROLL
		   S_StartSound(player.mo, sfx_djump)
		   P_SetObjectMomZ(player.mo, 17*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end   
	end	
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "table")
	    and (P_IsObjectOnGround(player.mo))
		and (player.buttontapping)
		and player.charging == false
	    and not player.weapondelay
		and not (player.powers[pw_shield])
		and not (player.powers[pw_super])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.weapondelay = 10
		S_StartSound(player.mo, sfx_spndsh)
		local ghost = P_SpawnGhostMobj(player.mo) 
		ghost.destscale = $*99
		ghost.scalespeed = $*2
	end
	if (player.mo.skin == "table")
	    and (P_IsObjectOnGround(player.mo))
		and (player.buttontapping)
		and player.charging == false
	    and not player.weapondelay
		and not (player.powers[pw_shield])
		and not (player.powers[pw_super])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		player.charging = true
		player.weapondelay = 10
		S_StartSound(player.mo, sfx_spndsh)
		local ghost = P_SpawnGhostMobj(player.mo) 
		ghost.destscale = $*99
		ghost.scalespeed = $*2
	end	
end)


addHook("PlayerThink", function(player)
	if not (player.cmd.buttons & BT_CUSTOM2) 
		player.buttontappready = true
		player.buttontapping = false
	elseif player.buttontappready
		player.buttontapping = true
		player.buttontappready = false
	else
		player.buttontapping = false
	end
end)



addHook("PlayerThink", function(player)
	if (P_IsObjectOnGround(player.mo))
	and (player.buttontapping)
	and player.charging == true
	and (player.mo.skin == "table")
	and not (player.powers[pw_super])
	and not player.weapondelay
		player.charging = false
		player.weapondelay = 10
		player.mo.state = S_PLAY_SPRING
		P_SetObjectMomZ(player.mo, 20*FRACUNIT)
		S_StartSound(player.mo, sfx_s3ka0)
		player.pflags = $ |PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
	end
	if (P_IsObjectOnGround(player.mo))
	and (player.buttontapping)
	and player.charging == true	
	and (player.mo.skin == "table")
	and (player.powers[pw_super])
	and not player.weapondelay
		player.charging = false
		player.weapondelay = 10
		player.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(player.mo, 25*FRACUNIT)
		S_StartSound(player.mo, sfx_s3ka0)
		player.pflags = $ |PF_JUMPED
		player.pflags = $ & ~PF_THOKKED
    end
end)


addHook("SpinSpecial", function(player)
    if (player.mo.skin == "table")
		if (player.mo.state == S_PLAY_SPRING)
		or (player.mo.state == S_PLAY_FALL)
		and not (player.powers[pw_super])
		   S_StartSound(player.mo, sfx_spin)
		   P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_ROLL
		end
	end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "table")
    and (player.mo.state == S_PLAY_ROLL)
        return true   
    end
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "table")
	and (p.pflags & PF_SPINNING)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)


addHook("PlayerThink", function(player)
    if player.mo.skin == "lemonade"
        and (player.cmd.buttons & BT_SPIN)
		and not (player.pflags & PF_STASIS)
		and not (player.pflags & PF_FULLSTASIS)
		and not (player.pflags & PF_STARTDASH)
		and not (player.pflags & PF_FINISHED)
		and not (player.xmomentum)
		and	player.playerstate ~= PST_DEAD
		and player.powers[pw_carry] == CR_NONE
		and not P_PlayerInPain(player) then
		player.normalspeed = 55*FRACUNIT
    else
		player.normalspeed = skins["lemonade"].normalspeed
		player.camerascale = skins["lemonade"].camerascale
    end	
end)


addHook("SpinSpecial", function(player)
    if (player.mo.skin == "lemonade")
		if (player.mo.state == S_PLAY_SPRING)
		or (player.mo.state == S_PLAY_FALL)
		and (player.cmd.buttons & BT_CUSTOM1)
		and not (player.powers[pw_super])
		and not (player.bonuce)
		   S_StartSound(player.mo, sfx_spin)
		   P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_JUMP
		end
	end
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "lemonade")
	and (player.mo.state == S_PLAY_ROLL)
        return true   
    end
end)


addHook("PlayerThink", function(player)
	if P_IsObjectOnGround(player.mo)
	and player.mo.skin == "lemonade"
	and (player.cmd.buttons & BT_CUSTOM1)
	and player.speed > 5*FRACUNIT
	and not (player.pflags & PF_SPINNING)
	    player.pflags = $ | PF_SPINNING
	    player.mo.state = S_PLAY_GLIDE
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "lemonade"
		if (player.mo.state == S_PLAY_JUMP)
		and (player.cmd.buttons & BT_CUSTOM2)
		and (player.playerstate == PST_LIVE)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
        and (P_IsObjectOnGround(player.mo) == false)
           P_SpawnThokMobj(player)
		   player.mo.state = S_PLAY_ROLL
		   player.bounce = true
		   player.powers[pw_strong] = STR_FLOOR
		   player.powers[pw_strong] = STR_SPRING
		   P_SetObjectMomZ(player.mo, -32*FRACUNIT)
		   S_StartSound(player.mo, sfx_zoom, player)
		end
		
		if (player.bounce)
		and (P_IsObjectOnGround(player.mo) == true)
		and not (player.powers[pw_super])
		and not (player.powers[pw_carry])
		and not (P_PlayerInPain(player))
		   player.bounce = false
		   player.powers[pw_strong] = $ & ~STR_FLOOR
		   player.powers[pw_strong] = $ & ~STR_SPRING
		   P_SetObjectMomZ(player.mo, 15*FRACUNIT)
		   player.mo.state = S_PLAY_SPRING
		   S_StartSound(player.mo, sfx_kc52, player)
		end
		
		if (player.bounce)
		and (P_IsObjectOnGround(player.mo) == true)
		and (player.powers[pw_super])
		and not (player.powers[pw_carry])
		and not (P_PlayerInPain(player))
		   player.bounce = false
		   player.powers[pw_strong] = $ & ~STR_FLOOR
		   player.powers[pw_strong] = $ & ~STR_SPRING
		   P_SetObjectMomZ(player.mo, 20*FRACUNIT)
		   player.mo.state = S_PLAY_SPRING
		   S_StartSound(player.mo, sfx_kc52, player)
		end
	end
end)


addHook("PlayerThink", function(player)	
	if (player.mo.skin == "lemonade")
	and (player.pflags & PF_SPINNING)
	and (P_IsObjectOnGround(player.mo))
	and not (player.pflags & PF_STARTDASH)
	    S_StartSound(player.mo, sfx_s3k7e)
		P_SpawnSkidDust(player, 15*FRACUNIT, sfx_none)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "lemonade")
	and (player.speed >= 50*FRACUNIT)
	    player.powers[pw_strong] = STR_DASH
		player.camerascale = skins["lemonade"].camerascale*2
		local afterimages2 = P_SpawnGhostMobj(player.mo)
		afterimages2.colorized = true
		afterimages2.color = ptafterimages[player.mo.afterimages_refresh]
		afterimages2.frame = $|FF_ADD
		afterimages2.fuse = 5
		afterimages2.blendmode = AST_TRANSLUCENT
		afterimages2.renderflags = player.mo.renderflags
	end	
	if not (player.speed >= 50*FRACUNIT)
	    player.camerascale = skins["lemonade"].camerascale
		player.powers[pw_strong] = $ & ~STR_DASH
	end
end)			



addHook("PlayerThink", function(p)
	if (p.mo.skin == "lemonade")
	and (p.pflags & PF_SPINNING)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)


local function thicc(p) -- Credit goes to NeonSRB2 for the Squash and Stretch code
	if p.mo.skin != "lemonade" then
		return
	end
	if p.jt == nil then
		p.jt = 0
		p.jp = false
		p.sp = false
		p.tk = false
		p.tr = false
	end
	if p.jt > 0 then
		p.jt = p.jt - 1
	end
	if p.jt < 0 then
		p.jt = p.jt + 1
	end
	if p.mo.momz < 1 then
		p.jp = false
	end
	if p.mo.state != S_PLAY_CLIMB and p.mo.eflags != p.mo.eflags | MFE_GOOWATER then
		if p.mo.momz > 0 and p.jp == false and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
		if p.mo.momz > 0 and p.jt < 0 and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
	elseif p.mo.eflags == p.mo.eflags | MFE_GOOWATER
		p.jp = true
	end
	if p.mo.state == S_PLAY_BOUNCE_LANDING then
		p.jt = -5
	end
	/*
	if p.pflags != p.pflags | PF_SPINNING or p.pflags == p.pflags | PF_JUMPED then
		p.sp = false
	end
	if p.pflags == p.pflags | PF_SPINNING and p.pflags != p.pflags | PF_JUMPED and p.sp == false and p.jt < 1 then
		p.sp = true
		p.jt = -5
	end
	*/
	if p.pflags != p.pflags | PF_THOKKED then
		p.tk = false
	end
	if p.pflags == p.pflags | PF_THOKKED and p.tk == false then
		p.tk = true
		p.jt = 5
	end
	if p.mo.state != S_PLAY_FLY_TIRED then
		p.tr = false
	end
	if p.mo.state == S_PLAY_FLY_TIRED and p.tr == false then
		p.tr = true
		p.jt = 5
	end
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.mo.spriteyscale = p.maths + FRACUNIT
	
	p.maths = p.jt*p.spinheight
	if p.mo.state != S_PLAY_ROLL then
		p.maths = p.jt*p.height
	end
	p.maths = p.maths / 20
	p.mo.spriteyoffset = -1*p.maths
	
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.maths = p.maths*-1
	p.mo.spritexscale = p.maths + FRACUNIT
end
addHook("PlayerThink", thicc)


// CUSTOMIZE SECTION START
local skin = "table" // your character here
local sound = sfx_s23c // the sound that plays when you enter speed booster mode
local sound2 = sfx_kc5b // the sound that plays when you enter speed booster mode
local runtime = 200 // how long you need to run to get your speed boost
local sbspeed = 55 // how fast the speed boost is
local hasdust = false // if this is true, you will spawn dust while boosting
local hasghost = true // if this is true, you will have a after effect while boosting
local dash = true // if this is true, you will be able to dash. (This is a modified script of Sp Moves Enjoyer)
// CUSTOMIZE SECTION END PROCCED BELOW IF YOU KNOW WHAT YOUR DOING

local function SpeedBoost_Reset(player)
	player.mo.sbruntime = 0
	player.normalspeed = skins[skin].normalspeed
	player.charflags = $1 & ~SF_RUNONWATER
	player.powers[pw_strong] = $ & ~STR_DASH
	player.camerascale = skins[skin].camerascale
end

addHook("PlayerThink", function(player)
	if player.mo.sbruntime == nil
		player.mo.sbruntime = 0
	end
	if player.mo.skin == skin 
	and player.speed > player.runspeed
		player.mo.sbruntime = $ + 1
	end
	if player.mo.skin == skin 
	and player.speed < player.runspeed
	and P_IsObjectOnGround(player.mo)
	and player.mo.sbruntime > 0
		SpeedBoost_Reset(player)
	end
	if player.mo.skin == skin 
	and player.speed < player.runspeed
	and P_IsObjectOnGround(player.mo)
	and player.mo.sbruntime > runtime
		S_StartSound(player.mo, sound2)
		SpeedBoost_Reset(player)
	end
	if player.mo.skin == skin 
	and player.mo.sbruntime == runtime
		S_StartSound(player.mo, sound)
	end
	if player.mo.skin == skin 
	and player.mo.sbruntime > runtime
		player.charflags = $1|SF_RUNONWATER
		player.normalspeed = sbspeed*FRACUNIT
		player.camerascale = skins["table"].camerascale*2
		if dash == true
			player.powers[pw_strong] = STR_DASH
		end
		if hasdust == true and P_IsObjectOnGround(player.mo)
			P_SpawnSkidDust(player, player.mo.radius, true)
		end
		if hasghost == true
		    local afterimages = P_SpawnGhostMobj(player.mo)
		    afterimages.colorized = true
		    afterimages.color = ptafterimages[player.mo.afterimages_refresh]
		    afterimages.frame = $|FF_ADD
		    afterimages.fuse = 5
			afterimages.blendmode = AST_TRANSLUCENT
		    afterimages.renderflags = player.mo.renderflags
	    end
	end
end)


addHook("PlayerThink", function(player)	
	if (player.mo.skin == "table")
	and (player.mo.state == S_PLAY_RUN)
	and (P_IsObjectOnGround(player.mo))
	and not (player.powers[pw_super])
	and not (player.mo.ultraform)
		P_SpawnSkidDust(player, 15*FRACUNIT, sfx_none)
	end
end)


addHook("PlayerThink", function(player)	
	if (player.mo.skin == "lemonade")
	and (player.mo.state == S_PLAY_RUN)
	and (P_IsObjectOnGround(player.mo))
	and not (player.powers[pw_super])
	and not (player.mo.ultraform)
		P_SpawnSkidDust(player, 15*FRACUNIT, sfx_none)
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_WALK) and (player.mo.frame == B) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "table")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_WALK) and (player.mo.frame == G) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "table")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_WALK) and (player.mo.frame == B) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "lemonade")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_WALK) and (player.mo.frame == G) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "lemonade")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_RUN) and (player.mo.frame == B) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "table")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_RUN) and (player.mo.frame == C) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "table")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_RUN) and (player.mo.frame == B) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "lemonade")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
	     if (player.mo.state == S_PLAY_RUN) and (player.mo.frame == C) and P_IsObjectOnGround(player.mo)
		 and (player.mo.skin == "lemonade")
	        S_StartSound(player.mo, sfx_kc50)
		end
	end
end)